Add bufr_filter/bufr_set test ECC-24

This commit is contained in:
Sandor Kertesz 2015-02-02 15:16:32 +00:00
parent bda29184f4
commit 9cf892767d
4 changed files with 132 additions and 7 deletions

View File

@ -35,6 +35,7 @@ list( APPEND tests
bufr_filter
bufr_json
bufr_ls
bufr_set
ieee
grib1to2
grib2to1

View File

@ -1,6 +1,6 @@
TESTS = definitions.sh calendar.sh \
bufrdc_desc_ref.sh bufrdc_ref.sh bufr_dump.sh bufr_filter.sh \
bufr_json.sh bufr_ls.sh \
bufr_json.sh bufr_ls.sh bufr_set.sh \
ieee.sh grib1to2.sh \
unit_tests.sh \
grib2to1.sh badgrib.sh ls.sh filter.sh \

View File

@ -100,7 +100,6 @@ EOF
#TODO: when ECC-32 is fixed we need to remove hack using the transient variables!
cat > $fRules <<EOF
set unpack=1;
transient centre_tmp=centre;
@ -124,23 +123,47 @@ done
# Test: with nonexistent keys.
#-----------------------------------------------------------
#TODO: when ECC-35 is fixed we need to enable this test again!
#Here "centre" is misspelled!!!
cat > $fRules <<EOF
set center="atlantis";
set center="98";
EOF
# Invoke without -f i.e. should fail if error encountered
set +e
f="syno_multi.bufr"
f="syno_1.bufr"
echo "Test: nonexistent keys" >> $fLog
echo "file: $f" >> $fLog
${tools_dir}/bufr_filter $fRules $f 2>> $fLog 1>> $fLog
if [ $? -eq 0 ]; then
echo "bufr_filter should have failed if key not found" >&2
#exit 1
exit 1
fi
set -e
# Now repeat with -f option (do not exit on error)
${tools_dir}/bufr_filter -f $fRules $f >> $fLog
#-----------------------------------------------------------
# Test: with not allowed key values
#-----------------------------------------------------------
#Here 1024 is out of range for centre (it is 8-bit only)
cat > $fRules <<EOF
set centre=1024;
EOF
# Invoke without -f i.e. should fail if error encountered
set +e
f="syno_1.bufr"
echo "Test: not allowed key values" >> $fLog
echo "file: $f" >> $fLog
${tools_dir}/bufr_filter $fRules $f 2>> $fLog 1>> $fLog
if [ $? -eq 0 ]; then
echo "bufr_filter should have failed if key value is not allowed" >&2
exit 1
fi
set -e

101
tests/bufr_set.sh Executable file
View File

@ -0,0 +1,101 @@
#!/bin/sh
# Copyright 2005-2015 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
#
# In applying this licence, ECMWF does not waive the privileges and immunities granted to it by
# virtue of its status as an intergovernmental organisation nor does it submit to any jurisdiction.
#
. ./include.sh
#set -x
#Enter data dir
cd ${data_dir}/bufr
#Define a common label for all the tmp files
label="bufr_set_test"
#Create log file
fLog=${label}".log"
rm -f $fLog
touch $fLog
#Define tmp bufr file
fBufrTmp=${label}".bufr.tmp"
#----------------------------------------------------
# Test: setting header for single message file
#----------------------------------------------------
rm -f $fBufrTmp | true
f="syno_1.bufr"
echo "Test: setting header for single message file" >> $fLog
echo "file: $f" >> $fLog
${tools_dir}/bufr_set -v -p centre,centre:l -s centre=222 $f $fBufrTmp >> $fLog
centre=`${tools_dir}/bufr_get -p centre $fBufrTmp`
[ $centre = "222" ]
#----------------------------------------------------
# Test: setting header for multi-message file
#----------------------------------------------------
rm -f $fBufrTmp | true
f="syno_multi.bufr"
echo "Test: setting header for multi-message file" >> $fLog
echo "file: $f" >> $fLog
${tools_dir}/bufr_set -v -p centre,centre:l -s centre=222 $f $fBufrTmp >> $fLog
for i in 1 2 3 ;do
centre=`${tools_dir}/bufr_get -w count=$i -p centre $fBufrTmp`
[ $centre = "222" ]
done
#-----------------------------------------------------
# Test: setting data values for single message file
#-----------------------------------------------------
#TODO: when ECC-37 is fixed we need to enable it.
rm -f $fBufrTmp | true
f="syno_1.bufr"
echo "Test: setting data values" >> $fLog
echo "file: $f" >> $fLog
#${tools_dir}/bufr_set -v -p airTemperatureAt2M -s airTemperatureAt2M=234.5 $f $fBufrTmp >> $fLog
#t2m=`${tools_dir}/bufr_get -p airTemperatureAt2M $fBufrTmp`
#[ $t2m = "234.5" ]
#----------------------------------------------------
# Test: setting header for multi-message file
#----------------------------------------------------
#TODO: when ECC-37 is fixed we need to enable it.
rm -f $fBufrTmp | true
f="syno_multi.bufr"
echo "Test: setting data values for multi-message file" >> $fLog
echo "file: $f" >> $fLog
#${tools_dir}/bufr_set -v -p airTemperatureAt2M -s airTemperatureAt2M=234.5 $f $fBufrTmp >> $fLog
#for i in 1 2 3 ;do
# centre=`${tools_dir}/bufr_get -F%.1f -w count=$i -p airTemperatureAt2M $fBufrTmp`
# [ $centre = "234.5" ]
#done
#Clean up
rm -f $fLog
rm -f $fBufrTmp | true